#! /usr/bin/env python
# coding: utf-8
'''
Created on 2011/12/31

@author: YukiF
'''


import pygame,math, random
from pygame.locals import *
import data,s_result
#-----------------------------------------------------------------------------

class s_stage(object):
    def __init__(self):
        # データリセット-----------------------------------------------------------
        data.reset_status()
        #---------------------------------------------------------------------
        # 画像ロード
        self.my_effect_img = pygame.image.load("./img/myef.png")
        self.scroll_bg_img = pygame.image.load("./img/bgf1.png")
        self.bg_moon = pygame.image.load("./img/tuki.png")
        self.star = pygame.image.load("./img/hosi.png")
        self.hajimari = pygame.image.load ("./img/start.png")
        self.owari    = pygame.image.load("./img/over.png")
        # 音声ロード
        self.dedede = pygame.mixer.Sound("./dat/dedede.wav")
        self.snd_once = True
        #---------------------------------------------------------------------
        # オブジェクト作成
        self.my = myChar()          # 自機オブジェクト
        self.char_effect = []       # 自機のエフェクトを入れるリスト
        self.char_effect_cnt = 0    #　自機エフェクトカウンタ（生成フレーム計測）
        self.starList = []          # お星様オブジェクトを入れるリスト
        self.info = infomation()    # 情報表示                 
        
        
        #　お星さま生成カウンタ
        self.star_cnt_delay = []
        self.star_cnt = []
        for i in range(9):
            self.star_cnt_delay.append(data.STAR_CNT_DELAY)
            self.star_cnt.append(data.STAR_CNT_BORN)
        
        # 背景
        self.bg_front = scrollBg(self.scroll_bg_img,1)        # スクロール背景手前
        self.bg_back = scrollBg(self.scroll_bg_img,0.2,24)    # スクロール背景奥
        self.moon_cnt = 4800         # 月の描画位置テーブル取得用カウンタ
        
        # 開始時、終了時演出用
        self.start = True
        self.start_end_cnt = 0
        
        
    def draw(self):
        # 月描画
        self.drawMoon()
        #　奥がわスクロール背景描画
        pygame.draw.rect(data.screen,data.COLOR["WHITE"],
                         [0,data.ws[1]-24,data.ws[0],24])
        self.bg_back.draw()
        
        # お星様描画
        self.drawStar()
        
        # エフェクト描画
        for i in self.char_effect:
            i.draw()
        
        # 自機描画
        self.my.draw()
        
        # 開始時、終了時演出
        if self.start:
            self.drawStart()
        
        if self.my.die:
            self.drawEnd()
        
        # 手前がわスクロール背景描画
        self.bg_front.draw()
        
        self.info.draw()
        
        # 各オブジェクト処理
        if self.start:
            self.moveStart()
        elif self.my.die:
            self.moveEnd()
        else:
            self.my.move()
        
        self.bg_back.move()
        self.bg_front.move()
        self.effect()
        self.moveStar()
        self.info.move()
        
    
    def effect(self):
    #-------------------------------------------------------------------------
    # エフェクトのmove処理はここにまとめる
        #-charEffect----------------------------------------------------------
        # move及び削除
        for i in range(len(self.char_effect)):
            self.char_effect[i].move()
        #    if self.char_effect[i].die:
        #        del self.char_effect[i]
        #    ↑ どうもこの方法だとバグがありそうな気がする
        
        d_cnt = 0
        while True:
            if len(self.char_effect) <= d_cnt:
                break
            if self.char_effect[d_cnt].die:
                del self.char_effect[d_cnt]
            else:
                d_cnt += 1

        # 生成 ゲージが0のときは生成しない
        if self.char_effect_cnt == 6:
            self.char_effect_cnt = 0
            if data.fly_power > 0:
                self.char_effect.append(charEffect([self.my.rect.left,
                                                    self.my.rect.top+20],
                                        self.my_effect_img ))
        else:
            self.char_effect_cnt += 1
    

    def moveStar(self):
    #-------------------------------------------------------------------------
    # お星さま移動処理、生成、削除
        #-生成----------------------------------------------------------------
        for i in range (len(self.star_cnt)):
            if self.star_cnt_delay[i] >= data.STAR_CNT_DELAY:
                if random.randint(0,self.star_cnt[i])==0:
                    self.starList.append(star(self.star))
                    self.star_cnt_delay[i] = 0
                    self.star_cnt[i] = data.STAR_CNT_BORN
                else:
                    self.star_cnt[i] -= 1
            else:
                self.star_cnt_delay[i] += 1
        
        #---------------------------------------------------------------------
        # Move、当たり判定
        for i in self.starList:
            i.move()
            i.collide(self.my.rect)
        #-削除----------------------------------------------------------------
        #for i in range(len(self.starList)-1) :
        #    if self.starList[i].die:
        #        del self.starList[i]
        d_cnt = 0
        while True:
            if len(self.starList) >= d_cnt:
                break
            if self.starList[d_cnt].die:
                del self.starList[d_cnt]
            else:
                d_cnt += 1
    def drawStar(self):
        for i in self.starList:
            i.draw()
    
    def drawMoon(self):
    #-------------------------------------------------------------------------
    # 月画像描画
        if self.moon_cnt >= len(data.moon_move_x):
            return
        data.screen.blit(self.bg_moon,
            [data.moon_move_x[int(self.moon_cnt)]-self.bg_moon.get_width()/2,
             data.moon_move_y[int(self.moon_cnt)]-self.bg_moon.get_height()/2,])
        self.moon_cnt+=0.5
    
    def drawStart(self):
    #-------------------------------------------------------------------------
    # 開始時演出
        if self.start_end_cnt > 15:
            data.screen.blit(self.hajimari,
                            [262,64])
    def moveStart(self):
        if self.start_end_cnt == 60:
            self.start = False
            return
        else:
            self.start_end_cnt += 1
    
    def drawEnd(self):
    #-------------------------------------------------------------------------
    # 終了時演出
        if self.start_end_cnt < 15:
            data.screen.blit(self.owari,
                            [300,64])
            if self.snd_once:
                self.dedede.play()
                self.snd_once=False
    def moveEnd(self):
        if self.start_end_cnt == -90:
            data.scene_next = s_result.s_result()
            data.scene_change = True
        else:
            self.start_end_cnt -= 1
    
#-----------------------------------------------------------------------------

class myChar(object):
    '''
    自機キャラクターのクラス
    '''
    def __init__(self):
        self.img = pygame.image.load("./img/me.png")

        # 当たり判定用ボックス
        self.rect = self.img.get_rect()
        
        #-自機初期位置等設定----------------------------------------------------
        #self.rect.left = 64
        #self.rect.top = ( (data.ws[1]//2) - (self.img.get_height()//2))
        self.rect.left = 0
        self.rect.top = 64
        self.hs = self.rect.width//2
        
        #上昇フラグ
        self.rise = False
        self.rise_cnt = 0   #上昇カウント
        
        #燃費カウンタ
        self.basic_cost_cnt = 0
        
        #Trueのとき、死亡
        self.die = False
        

    def draw(self):
        data.screen.blit(self.img, [self.rect.left ,self.rect.top])
    
    def move(self):
        #---------------------------------------------------------------------
        #　左クリック時、ゲージがあればジャンプ。
        if data.mouse_state.pushL_Now():
            if data.fly_power > 0 :
                self.rise = True
                self.rise_cnt = 30
                data.fly_power -= data.JUMP_COST
                if data.fly_power < 0:
                    data.fly_power = 0
        
        # 右クリック時、一定の割合の星を消費してゲージを最大まで回復する
        if data.mouse_state.pushR_Now():
            if data.star_num_now >= data.CURE_COST_BORDER:
                cost = int(data.star_num_now*data.CURE_COST/100.0)
                if cost < data.CURE_COST_BORDER:
                    cost = data.CURE_COST_BORDER
                data.star_num_now -= cost
                data.fly_power = data.FLY_POW_MAX
        
        # 移動量作成
        m = abs(self.rect.centerx - data.mouse_state.pos[0])
        m=int(math.sqrt(m*0.5)*0.5)
        if m <= 0:
            m=1
            
        # 自キャラよりマウスが左右にある場合移動させる
        if self.rect.centerx > data.mouse_state.pos[0] :
            self.rect.left -= m
        elif self.rect.centerx < data.mouse_state.pos[0] :
            self.rect.left += m
        
        # 上昇フラグがTrueの場合、rise_cntが0になるまで上昇する
        if self.rise:
            r = self.rise_cnt//4
            if r == 0:
                r = 1
            self.rect.top  -= r
            self.rise_cnt -= 1
            
            if self.rise_cnt == 0:
                self.rise = False
        # Falseの場合、常に下降、ゲージを一定フレーム毎に1消費する
        # ゲージ0の際は下降速度上昇
        else:
            if data.fly_power >0 :
                self.rect.top += 1
            else:
                self.rect.top += 5
            if (self.basic_cost_cnt == data.BASIC_COST):
                data.fly_power -= 1
                self.basic_cost_cnt = 0
                if data.fly_power < 0 :
                    data.fly_power = 0
            else :
                self.basic_cost_cnt += 1
        
        # 死亡判定
        if self.rect.top >= (data.ws[1] + self.rect.height) :
            self.die = True

#-----------------------------------------------------------------------------
class star(object):
    """
        おほしさま
    """
    def __init__(self, image):
        self.img = image    #表示画像への参照
        
        # 種類を決定
        if random.randint(0,150) > 0:
            if random.randint(0,15) > 0:
                self.type = random.randint(3,5)
            else:
                self.type = random.randint(0,2)
        else: 
            self.type = random.randint(6,7)
        
        self.die = False    #左はしから見切れるか、自機と接触したとき消滅
        
        self.anim_cnt = 0   # アニメーション用のカウンタ
        self.frame_cnt = 0  #　フレーム計測用カウンタ
        self.speed = random.randint(1,5) #スクロールスピード
        
        self.rect = pygame.Rect(data.ws[0],
                                random.randint(32,data.ws[1]-64),
                                32,32)
    
    def draw (self):
        if self.die:
            return
        data.screen.blit (self.img,self.rect,
                          [self.anim_cnt*32, self.type*32, 32, 32])
    
    def move (self):
        if self.die:
            return
        self.rect.right -= self.speed
        
        #　アニメーション処理
        if self.frame_cnt == 4:
            self.anim_cnt += 1
            self.frame_cnt = 0
        if self.anim_cnt > 3:
            self.anim_cnt = 0
        self.frame_cnt += 1
        
        #　見切れたらdieフラグをオン
        if self.rect.right < 0:
            self.die = True
            return
    
    def collide (self, rect):
    #-------------------------------------------------------------------------
    #　当たり判定処理。self.typeによって効果を分ける
        if self.die:
            return
        if rect.collidepoint(self.rect.center) == False:
            return
        
        tmp = data.STAR_EFFECT[self.type]    # 効果を取り出し
        data.star_num_now += tmp[0]     # 適応
        data.star_num_sum += tmp[0]
        data.star_num_type[self.type] += 1
        if data.star_num_max < data.star_num_now:
            data.star_num_max = data.star_num_now
        data.fly_power += tmp[1]
        if data.fly_power > data.FLY_POW_MAX :
            data.fly_power = data.FLY_POW_MAX
        
        # 特殊効果がある場合その処理（未実装）
        if tmp[2] == 1:
            pass
        elif tmp[2] == 2:
            pass
        
        self.die = True
        
#-----------------------------------------------------------------------------
class charEffect(object):
    '''
        自機の後ろに生成するエフェクト
    '''
    def __init__(self,pos,image):
        self.anim_cnt = 0   # アニメーション用のカウンタ
        self.frame_cnt = 0  # フレーム計測用カウンタ
        self.img = image    # 画像への参照
        self.pos = pos      # 表示位置
        self.die = False    # このTrueのとき、オブジェクトを削除する
    
    def draw (self):
        if self.die:
            return
        data.screen.blit(self.img,[self.pos[0],self.pos[1]],
                        [self.anim_cnt*16, 0, 16, 16])
    
    def move (self):
        if self.frame_cnt == 2:
            self.frame_cnt = 0
            self.anim_cnt += 1
        else:
            self.frame_cnt += 1
        
        if self.anim_cnt >= 20:
            self.die = True


#-----------------------------------------------------------------------------
class scrollBg(object):
    '''
        多重スクロールする背景描画クラス
    '''
    def __init__ (self, image, speed, offset = 0):
        self.speed = speed      # スクロールスピード
        self.pos = 0            # 左端位置
        self.offset = offset    # 下表示位置オフセット
        self.img = image        # 画像（メモリ削減のために参照渡しに変更）
    def draw(self):
        self.drawimg(int(self.pos))
        # 画像の左にスペースが残っている場合、画面が埋まるまで描画する
        _pos = self.pos + self.img.get_width()
        while True:
            if _pos >= data.ws[0]:
                break
            self.drawimg(int(_pos))
            _pos += self.img.get_width()
        
    def move(self):
        # 画像の描画位置が画面から見切れている場合、0位置に戻す
        if self.pos <= ( -1*(self.img.get_width() )) :
            self.pos = 0
        # 画像をスクロールする
        self.pos -= self.speed
        
    
    def drawimg(self,x):
        #----------------------------------------------------------------------
        # 横位置x、可変がWindow下に接する状態で画像を描画する
        #----------------------------------------------------------------------
        data.screen.blit (self.img,
                          [x, data.ws[1]-self.img.get_height()-self.offset])


#-----------------------------------------------------------------------------
class singleBg(object):
    '''
        ループ表示されない背景描画クラス
    image = 表示画像への参照
    speed　= スクロールスピード（-で逆方向へスクロール）
    pos   = 初期表示位置
    die   = 生成からdieフレーム目で削除フラグオン。0の場合、完全に画面外に出た時点でフラグオン
        注意    今のところ横スクロールゲームであることを想定しているため、上下へのスクロール、
                    上下にはみ出た場合の削除は未実装
    '''
    def __init__(self,image, speed, pos, die=0):
        self.img = image
        self.speed = speed      #移動スピード
        self.m_value = pos[0]   #総移動量
        self.rect = pygame.Rect(pos[0],pos[1],
                                self.img.get_width(),
                                self.img.get_height())
        
        if die==0:
            self.die_cnt = die
            self.oos = True
        else:
            self.oos = False
        
        self.die = False
        
    def draw(self):
        if self.die:
            return
        data.screen.blit (self.img, self.rect.topleft)

    def move(self):
        if self.oos:    # 画面外に出た時点で削除する場合
            if (self.rect.right < 0) or (self.rect.left>data.ws[0]):
                self.die = True
                return
        else:           # 指定フレームで削除する場合
            if self.die_cnt == 0:
                self.die = True
                return
        self.m_value -= self.speed
        self.rect.left = int(self.m_value)
        self.die_cnt -= 1

#-----------------------------------------------------------------------------
class infomation (object):
    def __init__(self):
        #-画像読込-------------------------------------------------------------
        self.gf  = pygame.image.load("./img/gf.png")
        self.bar = pygame.image.load("./img/kuro.png")
        self.hyoji = pygame.image.load("./img/hyoji.png")
        #-各種カウンタ------------------------------------------------------------
        self.frame_cnt = 0
        #-表示位置関係----------------------------------------------------------
        self.g_pos = (8,8)      #ゲージ表示位置
        #-Rect----------------------------------------------------------------
        self.bar_rect = pygame.Rect(0, 0, 320, 24)

    def draw(self):
        data.screen.blit (self.bar,[self.g_pos[0], self.g_pos[1]],
                          self.bar_rect)
        data.screen.blit (self.gf, [self.g_pos[0], self.g_pos[1]])
        
        # 星のかず表示
        data.screen.blit (self.hyoji,[400,4], [288,0,32,32])
        hosi = str(data.star_num_now)
        for i in range(len(hosi)):
            data.screen.blit(self.hyoji,[432+i*24,4],
                             [24*int(hosi[i]),0,24,32])
        
    
    def move(self):
        if self.frame_cnt == 4:
            self.frame_cnt = 0
            self.bar_rect.top = random.randint(0,self.bar.get_height()-25)
        else:
            self.frame_cnt += 1
        
        self.bar_rect.width = int ( (float(data.fly_power)/float(data.FLY_POW_MAX)) * 320.0 )